"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var oda_gen_common_1 = require("oda-gen-common");
var lodashProps = "\nmap: Path\nkeyBy: Path\neach: LodashOperations\n\n# Creates an array of elements split into groups the length of size.\n# If array can't be split evenly, the final chunk will be the remaining elements.\nchunk: Int\n\n# Creates a slice of array with n elements dropped from the beginning.\ndrop: Int\n\n# Creates a slice of array with n elements dropped from the end.\ndropRight: Int\n\n# Creates a slice of array with n elements taken from the beginning.\ntake: Int\n\n# Creates a slice of array with n elements taken from the end.\ntakeRight: Int\n\n# Recursively flatten array up to depth times.\nflattenDepth: Int\n\n# The inverse of `toPairs`; this method returns an object composed from key-value\n# pairs.\nfromPairs: DummyArgument\n\n# Gets the element at index n of array. If n is negative, the nth element from\n# the end is returned.\nnth: Int\n\n# Reverses array so that the first element becomes the last, the second element\n# becomes the second to last, and so on.\nreverse: DummyArgument\n\n# Creates a duplicate-free version of an array, in which only the first occurrence\n# of each element is kept. The order of result values is determined by the order\n# they occur in the array.\nuniq: DummyArgument\n\nuniqBy: Path\n\ncountBy: Path\nfilter: JSON\nreject: JSON\nfilterIf: Predicate\nrejectIf: Predicate\ngroupBy: Path\nsortBy: [Path!]\nmatch: RegExpr\nisMatch: RegExpr\n\nminBy: Path\nmaxBy: Path\nmeanBy: Path\nsumBy: Path\n\n# Converts all elements in array into a string separated by separator.\njoin: String\n\nget: Path\n# push selected item donw to the specified path\ndive: Path\n# get all fields of specified path to current object\nassign: [Path!]\nmapValues: Path\n\nconvert: ConvertTypeArgument\n\n# Creates an array of values corresponding to paths of object.\nat: [Path!]\n# Creates an array of own enumerable string keyed-value pairs for object.\ntoPairs: DummyArgument\n\n# Creates an object composed of the inverted keys and values of object.\n# If object contains duplicate values, subsequent values overwrite property\n# assignments of previous values.\ninvert: DummyArgument\n\ninvertBy: Path\n# Creates an array of the own enumerable property names of object.\nkeys: DummyArgument\n# Creates an array of the own enumerable string keyed property values of object.\nvalues: DummyArgument\n";
var Path = (function (_super) {
    __extends(Path, _super);
    function Path() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._name = 'Path';
        _this._resolver = {
            Path: {
                __serialize: String,
                __parseValue: String,
                __parseLiteral: function (x) { return x.value; },
            },
        };
        _this._typeDef = {
            type: ["\n      scalar Path\n    "],
        };
        return _this;
    }
    return Path;
}(oda_gen_common_1.types.GQLModule));
exports.Path = Path;
var RegularExpression = (function (_super) {
    __extends(RegularExpression, _super);
    function RegularExpression() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._name = 'RegularExpression';
        _this._typeDef = {
            type: ["\n        input RegExpr {\n          match: String!\n          flags: String\n        }\n    "],
        };
        return _this;
    }
    return RegularExpression;
}(oda_gen_common_1.types.GQLModule));
exports.RegularExpression = RegularExpression;
var Predicate = (function (_super) {
    __extends(Predicate, _super);
    function Predicate() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._name = 'Predicate';
        _this._typeDef = {
            type: ["\n        input Predicate {\n          lt: JSON\n          lte: JSON\n          gt: JSON\n          gte: JSON\n          eq: JSON\n          startsWith: String\n          endsWith: String\n          and: [Predicate!]\n          or: [Predicate!]\n        " + lodashProps + "\n        }\n    "],
        };
        return _this;
    }
    return Predicate;
}(oda_gen_common_1.types.GQLModule));
exports.Predicate = Predicate;
var DirectiveLodash = (function (_super) {
    __extends(DirectiveLodash, _super);
    function DirectiveLodash() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._name = 'DirectiveLodash';
        _this._typeDef = {
            type: ["\n      directive @_(\n        " + lodashProps + "\n      ) on FIELD | QUERY\n    "],
        };
        return _this;
    }
    return DirectiveLodash;
}(oda_gen_common_1.types.GQLModule));
exports.DirectiveLodash = DirectiveLodash;
var LodashOperations = (function (_super) {
    __extends(LodashOperations, _super);
    function LodashOperations() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._name = 'LodashOperations';
        _this._typeDef = {
            type: ["\n        input LodashOperations {\n          " + lodashProps + "\n        }\n    "],
        };
        return _this;
    }
    return LodashOperations;
}(oda_gen_common_1.types.GQLModule));
exports.LodashOperations = LodashOperations;
var DummyArgument = (function (_super) {
    __extends(DummyArgument, _super);
    function DummyArgument() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._name = 'DummyArgument';
        _this._typeDef = {
            type: ["\n      enum DummyArgument{\n        none\n      }\n    "],
        };
        return _this;
    }
    return DummyArgument;
}(oda_gen_common_1.types.GQLModule));
exports.DummyArgument = DummyArgument;
var ConvertTypeArgument = (function (_super) {
    __extends(ConvertTypeArgument, _super);
    function ConvertTypeArgument() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._name = 'ConvertTypeArgument';
        _this._typeDef = {
            type: ["\n      enum ConvertTypeArgument{\n        toNumber\n        toString\n      }\n    "],
        };
        return _this;
    }
    return ConvertTypeArgument;
}(oda_gen_common_1.types.GQLModule));
exports.ConvertTypeArgument = ConvertTypeArgument;
var LodashModule = (function (_super) {
    __extends(LodashModule, _super);
    function LodashModule() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._name = 'LodashModule';
        _this._extend = [
            new RegularExpression({}),
            new Path({}),
            new Predicate({}),
            new DirectiveLodash({}),
            new LodashOperations({}),
            new DummyArgument({}),
            new ConvertTypeArgument({}),
        ];
        return _this;
    }
    return LodashModule;
}(oda_gen_common_1.types.GQLModule));
exports.LodashModule = LodashModule;
//# sourceMappingURL=lodash.js.map